clear 
close all
load('traiX.mat');
load('queryX.mat');
load('T.mat');

ntrai = size(trai.X,2); %W{
d = size(trai.X,1); %
nquery = length(query.label); %eXgW{
nclass = max(trai.label);
imgsize = [112 92];

normalize=true; % K
svmlight.v=0;
svmlight.z='c';
svmlight.c=100;  % \tg}[W̃p[^
svmlight.t=0; % 0: `C1:(s a*b+c)^dC2:RBFexp(-gamma ||a-b||^2)C3:Sigmoid
svmlight.d=1; % d
svmlight.g=1e-2; % RBFgamma
svmlight.s=1; % /Sigmoids
svmlight.r=1; % /Sigmoidc
svmlight.option=sprintf('-v %d -z %c -c %f -t %d -d %d -g %f -s %f -r %f ',...
			svmlight.v, svmlight.z, svmlight.c, svmlight.t, ...
			svmlight.d, svmlight.g, svmlight.s, svmlight.r);

%%% K
if normalize 
  xnrm=sqrt(sum(trai.X.^2));
  trai.X = trai.X * diag( 1./xnrm);
  qnrm=sqrt(sum(query.X.^2));
  query.X = query.X * diag( 1./qnrm);
end

% SVMlightp̃R}h
if find(pwd==':')~=0 % windows̏ꍇ
	svm_learn = 'svm_learn'; % svm_learn
	svm_classify = 'svm_classify'; % svm_classify
	trainfile='train.svmexample'; %wKW{ꎞt@C
	testfile='test.svmexample'; %eXgW{ꎞt@C
	modelfile='model.svmlight'; %fꎞt@C
	outputfile='output.svmlight'; %o̓t@C
else
	svm_learn = './svm_learn'; % svm_learn
	svm_classify = './svm_classify'; % svm_classify
	trainfile='./train.svmexample'; %wKW{ꎞt@C
	testfile='./test.svmexample'; %eXgW{ꎞt@C
	modelfile='./model.svmlight'; %fꎞt@C
	outputfile='./output.svmlight'; %o̓t@C
end

%% eXgW{SVM-lighť`ŏo͂
fid = fopen( testfile, 'w');
for ii=1:nquery
  fprintf(fid,'0 ');
  fprintf(fid,'%d:%e ',[ [1:d]; query.X(:,ii)' ] );
  fprintf(fid,'\n');
end
fclose(fid);

feature=zeros(nclass,nquery);
for c=1:nclass
  fprintf(2,'Class %d...',c);
  
  %% NXcȂ1,ȊOȂ-1̃xNg쐬
  svmlabel = -1 * ones(1,ntrai);
  svmlabel( trai.label == c ) =1 ;
  
  %% SVM-lighť`Ńf[^o͂
  fid = fopen( trainfile, 'w');
  for ii=1:ntrai
    fprintf(fid,'%d ', svmlabel(ii) );
    fprintf(fid,'%d:%e ',[ [1:d]; trai.X(:,ii)' ] );
    fprintf(fid,'\n');
  end
  fclose(fid);
  
  %% SVM̊wK
  command = sprintf('%s %s %s %s\n', svm_learn, svmlight.option, trainfile, modelfile);
  [a b]=system(command);
  
  %% Support vector̐
	fid=fopen(modelfile, 'r');
	str = fscanf( fid, '%c');
	fclose(fid);
	fprintf(2,'OK, # of SV = %d\n',sum(str==10)-11);
	clear str

  %% 
  command = sprintf('%s %s %s %s\n',svm_classify, testfile, modelfile, outputfile);
  [a b]=system(command);
  feature(c,:) = load(outputfile)';
  
end

[tmp eclass] = max(feature);
accuracy = sum(eclass(:) == query.label(:))/nquery;
fprintf('accuracy = %.2f %%\n',accuracy*100 );

%% 뎯ʂ̂\
load('queryX.mat');
index = find( eclass(:) ~= query.label(:) );
for ii=1:min(length(index),9)
  subplot(3,3,ii);
  imagesc( reshape( T.m + T.U*query.X(:,index(ii)), imgsize(1), imgsize(2) ) );
  colormap('gray');
end
